// A Bison parser, made by GNU Bison 3.7.5.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file y.tab.h
 ** Define the lha::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_LHA_LHA_PARSER_HH_INCLUDED
# define YY_LHA_LHA_PARSER_HH_INCLUDED
// "%code requires" blocks.
#line 6 "../../../../src/ModelGenerator/LhaParser/Lha-parser.yy"

        #include <math.h>
        #include <limits.h>
        # include <string>

        #include <fstream>
        #include <sstream>
        #include <set>
        #include "../Eval/Eval.hpp"
        #include "../HaslFormula.hpp"

        class Lha_Reader;


        #define BUFF_SIZE 5000

#line 66 "Lha-parser.hh"


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif
# include "location.hh"


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

namespace lha {
#line 195 "Lha-parser.hh"




  /// A Bison parser.
  class Lha_parser
  {
  public:
#ifndef YYSTYPE
    /// Symbol semantic values.
    union semantic_type
    {
#line 34 "../../../../src/ModelGenerator/LhaParser/Lha-parser.yy"

        double       RealVal;
        int            IntVal;
        std::string *name;
        char expression[BUFF_SIZE];
        HaslFormulasTop *TOPHASL;

#line 216 "Lha-parser.hh"

    };
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m)
        : std::runtime_error (m)
        , location (l)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
        , location (s.location)
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

      location_type location;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        YYEMPTY = -2,
    END = 0,                       // "end of file"
    YYerror = 256,                 // error
    YYUNDEF = 257,                 // "invalid token"
    str = 258,                     // str
    rval = 259,                    // rval
    ival = 260,                    // ival
    SEMICOLON = 261,               // SEMICOLON
    COLON = 262,                   // COLON
    COMMA = 263,                   // COMMA
    LB = 264,                      // LB
    RB = 265,                      // RB
    LSB = 266,                     // LSB
    RSB = 267,                     // RSB
    SHARP = 268,                   // SHARP
    ALL = 269,                     // ALL
    BackSlash = 270,               // BackSlash
    EQ = 271,                      // EQ
    GEQ = 272,                     // GEQ
    LEQ = 273,                     // LEQ
    LL = 274,                      // LL
    GG = 275,                      // GG
    AND = 276,                     // AND
    OR = 277,                      // OR
    NOT = 278,                     // NOT
    TRUE = 279,                    // TRUE
    FALSE = 280,                   // FALSE
    DOUBLE = 281,                  // DOUBLE
    INT = 282,                     // INT
    DIV = 283,                     // DIV
    MUL = 284,                     // MUL
    PLUS = 285,                    // PLUS
    MINUS = 286,                   // MINUS
    POWER = 287,                   // POWER
    FLOOR = 288,                   // FLOOR
    MIN = 289,                     // MIN
    MAX = 290,                     // MAX
    MOD = 291,                     // MOD
    LhaMIN = 292,                  // LhaMIN
    LhaMAX = 293,                  // LhaMAX
    AVG = 294,                     // AVG
    VAR = 295,                     // VAR
    PROB = 296,                    // PROB
    SPRT = 297,                    // SPRT
    LAST = 298,                    // LAST
    INTEGRAL = 299,                // INTEGRAL
    MEAN = 300,                    // MEAN
    DISC = 301,                    // DISC
    NOTDET = 302,                  // NOTDET
    LhaName = 303,                 // LhaName
    Const = 304,                   // Const
    Hybrid = 305,                  // Hybrid
    NbLoc = 306,                   // NbLoc
    NbVar = 307,                   // NbVar
    VList = 308,                   // VList
    LList = 309,                   // LList
    Iloc = 310,                    // Iloc
    Floc = 311,                    // Floc
    locations = 312,               // locations
    edges = 313,                   // edges
    PDF = 314,                     // PDF
    CDF = 315,                     // CDF
    EXIST_TOK = 316,               // EXIST_TOK
    NOTALL_TOK = 317,              // NOTALL_TOK
    NEG = 318                      // NEG
      };
      /// Backward compatibility alias (Bison 3.6).
      typedef token_kind_type yytokentype;
    };

    /// Token kind, as returned by yylex.
    typedef token::yytokentype token_kind_type;

    /// Backward compatibility alias (Bison 3.6).
    typedef token_kind_type token_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 66, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_str = 3,                               // str
        S_rval = 4,                              // rval
        S_ival = 5,                              // ival
        S_SEMICOLON = 6,                         // SEMICOLON
        S_COLON = 7,                             // COLON
        S_COMMA = 8,                             // COMMA
        S_LB = 9,                                // LB
        S_RB = 10,                               // RB
        S_LSB = 11,                              // LSB
        S_RSB = 12,                              // RSB
        S_SHARP = 13,                            // SHARP
        S_ALL = 14,                              // ALL
        S_BackSlash = 15,                        // BackSlash
        S_EQ = 16,                               // EQ
        S_GEQ = 17,                              // GEQ
        S_LEQ = 18,                              // LEQ
        S_LL = 19,                               // LL
        S_GG = 20,                               // GG
        S_AND = 21,                              // AND
        S_OR = 22,                               // OR
        S_NOT = 23,                              // NOT
        S_TRUE = 24,                             // TRUE
        S_FALSE = 25,                            // FALSE
        S_DOUBLE = 26,                           // DOUBLE
        S_INT = 27,                              // INT
        S_DIV = 28,                              // DIV
        S_MUL = 29,                              // MUL
        S_PLUS = 30,                             // PLUS
        S_MINUS = 31,                            // MINUS
        S_POWER = 32,                            // POWER
        S_FLOOR = 33,                            // FLOOR
        S_MIN = 34,                              // MIN
        S_MAX = 35,                              // MAX
        S_MOD = 36,                              // MOD
        S_LhaMIN = 37,                           // LhaMIN
        S_LhaMAX = 38,                           // LhaMAX
        S_AVG = 39,                              // AVG
        S_VAR = 40,                              // VAR
        S_PROB = 41,                             // PROB
        S_SPRT = 42,                             // SPRT
        S_LAST = 43,                             // LAST
        S_INTEGRAL = 44,                         // INTEGRAL
        S_MEAN = 45,                             // MEAN
        S_DISC = 46,                             // DISC
        S_NOTDET = 47,                           // NOTDET
        S_LhaName = 48,                          // LhaName
        S_Const = 49,                            // Const
        S_Hybrid = 50,                           // Hybrid
        S_NbLoc = 51,                            // NbLoc
        S_NbVar = 52,                            // NbVar
        S_VList = 53,                            // VList
        S_LList = 54,                            // LList
        S_Iloc = 55,                             // Iloc
        S_Floc = 56,                             // Floc
        S_locations = 57,                        // locations
        S_edges = 58,                            // edges
        S_PDF = 59,                              // PDF
        S_CDF = 60,                              // CDF
        S_EXIST_TOK = 61,                        // EXIST_TOK
        S_NOTALL_TOK = 62,                       // NOTALL_TOK
        S_NEG = 63,                              // NEG
        S_64_ = 64,                              // '{'
        S_65_ = 65,                              // '}'
        S_YYACCEPT = 66,                         // $accept
        S_LHA = 67,                              // LHA
        S_declarations = 68,                     // declarations
        S_IntMarkingFormula = 69,                // IntMarkingFormula
        S_RealMarkingFormula = 70,               // RealMarkingFormula
        S_RealVarMarkingFormula = 71,            // RealVarMarkingFormula
        S_ColorClassList = 72,                   // ColorClassList
        S_Sizes = 73,                            // Sizes
        S_Constants = 74,                        // Constants
        S_HybridVars = 75,                       // HybridVars
        S_Constant = 76,                         // Constant
        S_HybridVar = 77,                        // HybridVar
        S_NbVariables = 78,                      // NbVariables
        S_NbLocations = 79,                      // NbLocations
        S_Lists = 80,                            // Lists
        S_VariablesList = 81,                    // VariablesList
        S_VLabels = 82,                          // VLabels
        S_LocationsList = 83,                    // LocationsList
        S_LLabels = 84,                          // LLabels
        S_InitFinal = 85,                        // InitFinal
        S_init = 86,                             // init
        S_iLLabels = 87,                         // iLLabels
        S_final = 88,                            // final
        S_fLLabels = 89,                         // fLLabels
        S_definitions = 90,                      // definitions
        S_LocationsDef = 91,                     // LocationsDef
        S_LOCATIONS = 92,                        // LOCATIONS
        S_LOCATION = 93,                         // LOCATION
        S_FLOWS = 94,                            // FLOWS
        S_FLOW = 95,                             // FLOW
        S_LogExpr = 96,                          // LogExpr
        S_CompExpr = 97,                         // CompExpr
        S_EdgesDef = 98,                         // EdgesDef
        S_EDGES = 99,                            // EDGES
        S_EDGE = 100,                            // EDGE
        S_ACTIONS = 101,                         // ACTIONS
        S_SetOfActions = 102,                    // SetOfActions
        S_Actions = 103,                         // Actions
        S_CONSTRAINTS = 104,                     // CONSTRAINTS
        S_CONSTRAINT = 105,                      // CONSTRAINT
        S_LinearExp = 106,                       // LinearExp
        S_term = 107,                            // term
        S_UPDATES = 108,                         // UPDATES
        S_Updates = 109,                         // Updates
        S_Update = 110,                          // Update
        S_HaslExps = 111,                        // HaslExps
        S_HaslExp = 112,                         // HaslExp
        S_rorival = 113,                         // rorival
        S_TopHaslExp = 114,                      // TopHaslExp
        S_AlgExpr = 115,                         // AlgExpr
        S_LhaFunc = 116,                         // LhaFunc
        S_LinForm = 117,                         // LinForm
        S_VarTerm = 118                          // VarTerm
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ()
        : value ()
        , location ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value (std::move (that.value))
        , location (std::move (that.location))
      {}
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);
      /// Constructor for valueless symbols.
      basic_symbol (typename Base::kind_type t,
                    YY_MOVE_REF (location_type) l);

      /// Constructor for symbols with semantic value.
      basic_symbol (typename Base::kind_type t,
                    YY_RVREF (semantic_type) v,
                    YY_RVREF (location_type) l);

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }

      /// Destroy contents, and record that is empty.
      void clear () YY_NOEXCEPT
      {
        Base::clear ();
      }

      /// The user-facing name of this symbol.
      std::string name () const YY_NOEXCEPT
      {
        return Lha_parser::symbol_name (this->kind ());
      }

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// Default constructor.
      by_kind ();

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that);
#endif

      /// Copy constructor.
      by_kind (const by_kind& that);

      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t);

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// Backward compatibility for a private implementation detail (Bison 3.6).
    typedef by_kind by_type;

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {};

    /// Build a parser object.
    Lha_parser (Lha_Reader& Reader_yyarg);
    virtual ~Lha_parser ();

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    Lha_parser (const Lha_parser&) = delete;
    /// Non copyable.
    Lha_parser& operator= (const Lha_parser&) = delete;
#endif

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static std::string symbol_name (symbol_kind_type yysymbol);



    class context
    {
    public:
      context (const Lha_parser& yyparser, const symbol_type& yyla);
      const symbol_type& lookahead () const YY_NOEXCEPT { return yyla_; }
      symbol_kind_type token () const YY_NOEXCEPT { return yyla_.kind (); }
      const location_type& location () const YY_NOEXCEPT { return yyla_.location; }

      /// Put in YYARG at most YYARGN of the expected tokens, and return the
      /// number of tokens stored in YYARG.  If YYARG is null, return the
      /// number of expected tokens (guaranteed to be less than YYNTOKENS).
      int expected_tokens (symbol_kind_type yyarg[], int yyargn) const;

    private:
      const Lha_parser& yyparser_;
      const symbol_type& yyla_;
    };

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    Lha_parser (const Lha_parser&);
    /// Non copyable.
    Lha_parser& operator= (const Lha_parser&);
#endif


    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// The arguments of the error message.
    int yy_syntax_error_arguments_ (const context& yyctx,
                                    symbol_kind_type yyarg[], int yyargn) const;

    /// Generate an error message.
    /// \param yyctx     the context in which the error occurred.
    virtual std::string yysyntax_error_ (const context& yyctx) const;
    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_type enum.
    static symbol_kind_type yytranslate_ (int t);

    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *yystr);

    /// For a symbol, its name in clear.
    static const char* const yytname_[];


    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const unsigned char yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
    // symbol of state STATE-NUM.
    static const signed char yystos_[];

    // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
    static const signed char yyr1_[];

    // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
    static const signed char yyr2_[];


#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r) const;
    /// Print the state stack on the debug stream.
    virtual void yy_stack_print_ () const;

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol kind, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol kind as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_state& that);

      /// The symbol kind (corresponding to \a state).
      /// \a symbol_kind::S_YYEMPTY when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::iterator iterator;
      typedef typename S::const_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200)
        : seq_ (n)
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Non copyable.
      stack (const stack&) = delete;
      /// Non copyable.
      stack& operator= (const stack&) = delete;
#endif

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.begin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.end ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range)
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
#if YY_CPLUSPLUS < 201103L
      /// Non copyable.
      stack (const stack&);
      /// Non copyable.
      stack& operator= (const stack&);
#endif
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1);

    /// Constants.
    enum
    {
      yylast_ = 859,     ///< Last index in yytable_.
      yynnts_ = 53,  ///< Number of nonterminal symbols.
      yyfinal_ = 35 ///< Termination state number.
    };


    // User arguments.
    Lha_Reader& Reader;

  };


} // lha
#line 970 "Lha-parser.hh"




#endif // !YY_LHA_LHA_PARSER_HH_INCLUDED
